/*
 * FIFO implementation.
 */

#ifndef _fifo_h_
#define _fifo_h_

class FIFOReplacementAlg: public ReplacementAlg {
public:
	FIFOReplacementAlg(unsigned long num_frame, int page_bits):
		ReplacementAlg(num_frame, page_bits), m_nextrepl(0) { }

	virtual string name() { return "FIFO"; }

	virtual unsigned long fault(const Ref &r) {
		return increal(m_nextrepl);
	}
protected:
	unsigned long m_nextrepl;		// Next to replace.
};

#endif
